commit c1c3cfe7b83e960087c9b09332ae3c643af6e049
Author: Cherian Mathew <c.mathew@bgbm.org>
Date:   Mon Apr 13 17:29:02 2015 +0200

    added corrected dataset

diff --git a/src/test/resources/eu/etaxonomy/cdm/vaadin/presenter/NewTaxonBasePresenterTest.xml b/src/test/resources/eu/etaxonomy/cdm/vaadin/presenter/NewTaxonBasePresenterTest.xml
index 2bf52d3d..72fe8fc1 100644
--- a/src/test/resources/eu/etaxonomy/cdm/vaadin/presenter/NewTaxonBasePresenterTest.xml
+++ b/src/test/resources/eu/etaxonomy/cdm/vaadin/presenter/NewTaxonBasePresenterTest.xml
@@ -1,15 +1,19 @@
 <?xml version="1.0" encoding="UTF-8"?><!--
-  generated by Jailer 4.3, Fri Apr 10 15:48:47 CEST 2015 from cmathew@cmbgbm-t530
+  generated by Jailer 4.3, Mon Apr 13 17:27:53 CEST 2015 from cmathew@cmbgbm-t530
   
-  Extraction Model:  all rows from Classification (extractionmodel/by-example/SbE-Classification-15-48-33-101.csv)
+  Extraction Model:  all rows from Classification (extractionmodel/by-example/SbE-Classification-17-27-41-688.csv)
   Database URL:      jdbc:mysql://127.0.0.1:3306/local-redlist
   Database User:     root
   
-  Exported Rows:     22
+  Exported Rows:     67
+      AgentBase                      7
       Classification                 2
+      HomotypicalGroup               10
       LanguageString                 2
       Reference                      2
-      TaxonBase                      7
+      SynonymRelationship            7
+      TaxonBase                      14
+      TaxonNameBase                  14
       TaxonNode                      9
   
 --><dataset>
@@ -23,22 +27,71 @@
   <TaxonNode id="18" created="2015-03-09 15:53:32.0" uuid="5c43f991-c4ad-414b-a4f3-2d6a26ff1ccf" updated="2015-03-09 15:53:32.0" countchildren="0" sortindex="2" treeindex="#t12#15#18#" createdby_id="10" updatedby_id="10" classification_id="12" parent_id="15" taxon_id="20"/>
   <TaxonNode id="20" created="2015-03-10 13:40:31.0" uuid="6a6ee4dd-5727-47ba-a53d-3a985623dd93" updated="2015-03-10 13:40:31.0" countchildren="0" sortindex="3" treeindex="#t11#11#20#" createdby_id="10" updatedby_id="10" classification_id="11" parent_id="11" taxon_id="30"/>
 
+  <HomotypicalGroup id="10" created="2015-03-09 15:49:22.0" uuid="d7dd294a-8750-4ca9-afc2-b0beebaa53fa" updated="2015-03-09 15:49:25.0" createdby_id="10" updatedby_id="10"/>
+  <HomotypicalGroup id="11" created="2015-03-09 15:49:30.0" uuid="5eb658bb-f57c-4ec6-94a2-91dbeffce78e" updated="2015-03-09 15:50:21.0" createdby_id="10" updatedby_id="10"/>
+  <HomotypicalGroup id="12" created="2015-03-09 15:51:11.0" uuid="5391912e-b258-479c-bcec-eb0bb5cb088b" updated="2015-03-09 15:51:14.0" createdby_id="10" updatedby_id="10"/>
+  <HomotypicalGroup id="13" created="2015-03-09 15:51:24.0" uuid="d01dd053-24d9-4798-b37f-6f42da3e08dd" updated="2015-03-09 15:51:25.0" createdby_id="10" updatedby_id="10"/>
+  <HomotypicalGroup id="14" created="2015-03-09 15:52:34.0" uuid="22cc414a-ab6d-45fc-908a-984cebf4d1cd" updated="2015-03-09 15:52:42.0" createdby_id="10" updatedby_id="10"/>
+  <HomotypicalGroup id="15" created="2015-03-09 15:53:06.0" uuid="1f880e81-8bdf-40ec-bc2c-f13ded6665a9" updated="2015-03-09 15:53:07.0" createdby_id="10" updatedby_id="10"/>
+  <HomotypicalGroup id="16" created="2015-03-09 15:53:21.0" uuid="a441da3a-8dc7-413f-b17a-a8c80e4b4c3f" updated="2015-03-09 15:53:23.0" createdby_id="10" updatedby_id="10"/>
+  <HomotypicalGroup id="17" created="2015-03-09 15:53:30.0" uuid="bafedb10-2a56-4457-8c48-ecb0aae18bf5" updated="2015-03-09 15:53:32.0" createdby_id="10" updatedby_id="10"/>
+  <HomotypicalGroup id="20" created="2015-03-10 13:40:30.0" uuid="61c41e51-72cd-40d1-9a56-554732036c57" updated="2015-03-10 13:40:31.0" createdby_id="10" updatedby_id="10"/>
+  <HomotypicalGroup id="30" created="2015-04-10 10:31:09.0" uuid="91f7c49a-cb6f-457f-9483-4ae85706d0aa" updated="2015-04-10 10:31:09.0"/>
+
   <LanguageString id="11" created="2015-03-09 15:48:39.0" uuid="74793377-eeec-40e1-a971-b1b7e65c05f2" updated="2015-03-09 15:48:42.0" text="Classification1" createdby_id="10" updatedby_id="10" language_id="124"/>
   <LanguageString id="12" created="2015-03-09 15:52:14.0" uuid="0bcb7acf-a6c4-4715-a30e-d02614c9f799" updated="2015-03-09 15:52:24.0" text="Classification2" createdby_id="10" updatedby_id="10" language_id="124"/>
 
+  <TaxonNameBase DTYPE="BotanicalName" id="10" created="2015-03-09 15:49:22.0" uuid="9c0b6c13-562e-4642-9494-58dbcedf45f4" updated="2015-03-09 15:49:25.0" protectedtitlecache="false" titleCache="Taxon A" fullTitleCache="Taxon A" parsingproblem="0" problemends="5" problemstarts="0" protectedfulltitlecache="false" authorshipcache="A" binomhybrid="false" genusoruninomial="Taxon" hybridformula="false" monomhybrid="false" namecache="Taxon" protectedauthorshipcache="false" protectednamecache="false" trinomhybrid="false" anamorphic="false" createdby_id="10" updatedby_id="10" homotypicalgroup_id="10" rank_id="790" combinationauthorteam_id="10"/>
+  <TaxonNameBase DTYPE="BotanicalName" id="11" created="2015-03-09 15:49:30.0" uuid="82de3687-f90d-4968-951b-456a21659666" updated="2015-03-09 15:50:21.0" protectedtitlecache="true" titleCache="HTSynonym A1" fullTitleCache="HTSynonym A1" parsingproblem="4" problemends="12" problemstarts="0" protectedfulltitlecache="true" authorshipcache="" binomhybrid="false" hybridformula="false" monomhybrid="false" namecache="HTSynonym A1" protectedauthorshipcache="false" protectednamecache="true" trinomhybrid="false" anamorphic="false" createdby_id="10" updatedby_id="10" homotypicalgroup_id="11"/>
+  <TaxonNameBase DTYPE="BotanicalName" id="12" created="2015-03-09 15:50:25.0" uuid="bd86d4f9-8427-4ac5-a8c2-48add63da449" updated="2015-03-09 15:50:54.0" protectedtitlecache="true" titleCache="HMSynonym A1" fullTitleCache="HMSynonym A1" parsingproblem="4" problemends="12" problemstarts="0" protectedfulltitlecache="true" authorshipcache="" binomhybrid="false" hybridformula="false" monomhybrid="false" namecache="HMSynonym A1" protectedauthorshipcache="false" protectednamecache="true" trinomhybrid="false" anamorphic="false" createdby_id="10" updatedby_id="10" homotypicalgroup_id="10"/>
+  <TaxonNameBase DTYPE="BotanicalName" id="13" created="2015-03-09 15:51:11.0" uuid="fb76b9cb-29d2-4986-a327-19d1d003159a" updated="2015-03-09 15:51:14.0" protectedtitlecache="false" titleCache="Taxon B" fullTitleCache="Taxon B" parsingproblem="0" problemends="5" problemstarts="0" protectedfulltitlecache="false" authorshipcache="B" binomhybrid="false" genusoruninomial="Taxon" hybridformula="false" monomhybrid="false" namecache="Taxon" protectedauthorshipcache="false" protectednamecache="false" trinomhybrid="false" anamorphic="false" createdby_id="10" updatedby_id="10" homotypicalgroup_id="12" rank_id="790" combinationauthorteam_id="11"/>
+  <TaxonNameBase DTYPE="BotanicalName" id="14" created="2015-03-09 15:51:24.0" uuid="a21d5e7c-e8b5-4395-b83b-a219877e80eb" updated="2015-03-09 15:51:25.0" protectedtitlecache="false" titleCache="Taxon C" fullTitleCache="Taxon C" parsingproblem="0" problemends="5" problemstarts="0" protectedfulltitlecache="false" authorshipcache="C" binomhybrid="false" genusoruninomial="Taxon" hybridformula="false" monomhybrid="false" namecache="Taxon" protectedauthorshipcache="false" protectednamecache="false" trinomhybrid="false" anamorphic="false" createdby_id="10" updatedby_id="10" homotypicalgroup_id="13" rank_id="790" combinationauthorteam_id="12"/>
+  <TaxonNameBase DTYPE="BotanicalName" id="15" created="2015-03-09 15:51:31.0" uuid="7dd4eaa3-b65f-4d1e-8d2c-26a31ea3ae0b" updated="2015-03-09 15:51:44.0" protectedtitlecache="true" titleCache="HTSynonym C1" fullTitleCache="HTSynonym C1" parsingproblem="4" problemends="12" problemstarts="0" protectedfulltitlecache="true" authorshipcache="" binomhybrid="false" hybridformula="false" monomhybrid="false" namecache="HTSynonym C1" protectedauthorshipcache="false" protectednamecache="true" trinomhybrid="false" anamorphic="false" createdby_id="10" updatedby_id="10" homotypicalgroup_id="13"/>
+  <TaxonNameBase DTYPE="BotanicalName" id="16" created="2015-03-09 15:52:34.0" uuid="81444d5e-122f-46aa-9bee-d7c0ba52f8d6" updated="2015-03-09 15:52:42.0" protectedtitlecache="false" titleCache="Taxon A" fullTitleCache="Taxon A" parsingproblem="0" problemends="5" problemstarts="0" protectedfulltitlecache="false" authorshipcache="A" binomhybrid="false" genusoruninomial="Taxon" hybridformula="false" monomhybrid="false" namecache="Taxon" protectedauthorshipcache="false" protectednamecache="false" trinomhybrid="false" anamorphic="false" createdby_id="10" updatedby_id="10" homotypicalgroup_id="14" rank_id="790" combinationauthorteam_id="13"/>
+  <TaxonNameBase DTYPE="BotanicalName" id="17" created="2015-03-09 15:52:53.0" uuid="dcdfbc9f-5596-4ae2-85e0-b9c738d8bcec" updated="2015-03-09 15:52:57.0" protectedtitlecache="true" titleCache="HMSynonym A1" fullTitleCache="HMSynonym A1" parsingproblem="4" problemends="12" problemstarts="0" protectedfulltitlecache="true" authorshipcache="" binomhybrid="false" hybridformula="false" monomhybrid="false" namecache="HMSynonym A1" protectedauthorshipcache="false" protectednamecache="true" trinomhybrid="false" anamorphic="false" createdby_id="10" updatedby_id="10" homotypicalgroup_id="14"/>
+  <TaxonNameBase DTYPE="BotanicalName" id="18" created="2015-03-09 15:53:06.0" uuid="fa186915-0bb5-4047-a5c5-404d75851f1c" updated="2015-03-09 15:53:07.0" protectedtitlecache="true" titleCache="HTSynonym A1" fullTitleCache="HTSynonym A1" parsingproblem="4" problemends="12" problemstarts="0" protectedfulltitlecache="true" authorshipcache="" binomhybrid="false" hybridformula="false" monomhybrid="false" namecache="HTSynonym A1" protectedauthorshipcache="false" protectednamecache="true" trinomhybrid="false" anamorphic="false" createdby_id="10" updatedby_id="10" homotypicalgroup_id="15"/>
+  <TaxonNameBase DTYPE="BotanicalName" id="19" created="2015-03-09 15:53:21.0" uuid="fddf69fa-4f25-4d10-b693-1a9d5d7bbd5c" updated="2015-03-09 15:53:23.0" protectedtitlecache="false" titleCache="Taxon B" fullTitleCache="Taxon B" parsingproblem="0" problemends="5" problemstarts="0" protectedfulltitlecache="false" authorshipcache="B" binomhybrid="false" genusoruninomial="Taxon" hybridformula="false" monomhybrid="false" namecache="Taxon" protectedauthorshipcache="false" protectednamecache="false" trinomhybrid="false" anamorphic="false" createdby_id="10" updatedby_id="10" homotypicalgroup_id="16" rank_id="790" combinationauthorteam_id="14"/>
+  <TaxonNameBase DTYPE="BotanicalName" id="20" created="2015-03-09 15:53:30.0" uuid="9e644031-9190-4a4f-94bb-fc1f6066bbab" updated="2015-03-09 15:53:32.0" protectedtitlecache="false" titleCache="Taxon C" fullTitleCache="Taxon C" parsingproblem="0" problemends="5" problemstarts="0" protectedfulltitlecache="false" authorshipcache="C" binomhybrid="false" genusoruninomial="Taxon" hybridformula="false" monomhybrid="false" namecache="Taxon" protectedauthorshipcache="false" protectednamecache="false" trinomhybrid="false" anamorphic="false" createdby_id="10" updatedby_id="10" homotypicalgroup_id="17" rank_id="790" combinationauthorteam_id="15"/>
+  <TaxonNameBase DTYPE="BotanicalName" id="21" created="2015-03-09 15:53:49.0" uuid="0755d9d7-007a-4d81-a2f8-2ba1b7020cf4" updated="2015-03-09 15:53:52.0" protectedtitlecache="true" titleCache="HTSynonym C1" fullTitleCache="HTSynonym C1" parsingproblem="4" problemends="12" problemstarts="0" protectedfulltitlecache="true" authorshipcache="" binomhybrid="false" hybridformula="false" monomhybrid="false" namecache="HTSynonym C1" protectedauthorshipcache="false" protectednamecache="true" trinomhybrid="false" anamorphic="false" createdby_id="10" updatedby_id="10" homotypicalgroup_id="17"/>
+  <TaxonNameBase DTYPE="BotanicalName" id="30" created="2015-03-10 13:40:30.0" uuid="b1b9abf0-72a6-4a2e-8bd1-3ef189f5b3e9" updated="2015-03-10 13:40:31.0" protectedtitlecache="false" titleCache="Taxon D" fullTitleCache="Taxon D" parsingproblem="1" problemends="5" problemstarts="0" protectedfulltitlecache="false" authorshipcache="D" binomhybrid="false" genusoruninomial="Taxon" hybridformula="false" monomhybrid="false" namecache="Taxon" protectedauthorshipcache="false" protectednamecache="false" trinomhybrid="false" anamorphic="false" createdby_id="10" updatedby_id="10" homotypicalgroup_id="20" rank_id="800" combinationauthorteam_id="20"/>
+  <TaxonNameBase DTYPE="NonViralName" id="40" created="2015-04-10 10:31:09.0" uuid="98637ee9-d6b6-4a30-8bb9-17beda8856db" updated="2015-04-10 10:31:09.0" protectedtitlecache="true" titleCache="Synonym A" fullTitleCache="Synonym A" parsingproblem="0" problemends="-1" problemstarts="-1" protectedfulltitlecache="false" authorshipcache="" binomhybrid="false" hybridformula="false" monomhybrid="false" namecache="" protectedauthorshipcache="false" protectednamecache="false" trinomhybrid="false" homotypicalgroup_id="30"/>
+
   <Classification id="11" created="2015-03-09 15:48:30.0" uuid="6595638e-4993-421a-9fe5-76b09d94f36a" updated="2015-03-09 15:48:42.0" protectedtitlecache="false" titleCache="Classification1" createdby_id="10" updatedby_id="10" name_id="11" rootnode_id="11"/>
   <Classification id="12" created="2015-03-09 15:52:08.0" uuid="1ef8aada-de72-4023-bbe1-14465b6bc60d" updated="2015-03-09 15:52:24.0" protectedtitlecache="false" titleCache="Classification2" createdby_id="10" updatedby_id="10" name_id="12" rootnode_id="15"/>
 
   <TaxonBase DTYPE="Taxon" id="10" created="2015-03-09 15:49:22.0" uuid="666b484f-dc1e-4578-b404-86bc6d2e47fa" updated="2015-03-09 15:49:25.0" protectedtitlecache="false" titleCache="Taxon A sec. Book Reference 1" doubtful="false" publish="false" usenamecache="false" excluded="false" taxonstatusunknown="false" taxonomicchildrencount="0" unplaced="true" createdby_id="10" updatedby_id="10" name_id="10" sec_id="20"/>
+  <TaxonBase DTYPE="Synonym" id="11" created="2015-03-09 15:49:30.0" uuid="f45a4860-451d-493c-ad42-bbe68325a883" updated="2015-03-09 15:50:21.0" protectedtitlecache="false" titleCache="HTSynonym A1 sec. ???" doubtful="false" publish="true" usenamecache="false" createdby_id="10" updatedby_id="10" name_id="11"/>
+  <TaxonBase DTYPE="Synonym" id="12" created="2015-03-09 15:50:25.0" uuid="cdd8945e-d538-4141-8c1b-78c93a8e3a8b" updated="2015-03-09 15:50:54.0" protectedtitlecache="false" titleCache="HMSynonym A1 sec. ???" doubtful="false" publish="true" usenamecache="false" createdby_id="10" updatedby_id="10" name_id="12"/>
   <TaxonBase DTYPE="Taxon" id="13" created="2015-03-09 15:51:11.0" uuid="77e7d93e-75c6-4dd4-850d-7b5809654378" updated="2015-03-09 15:51:14.0" protectedtitlecache="false" titleCache="Taxon B sec. ???" doubtful="false" publish="true" usenamecache="false" excluded="false" taxonstatusunknown="false" taxonomicchildrencount="0" unplaced="false" createdby_id="10" updatedby_id="10" name_id="13"/>
   <TaxonBase DTYPE="Taxon" id="14" created="2015-03-09 15:51:24.0" uuid="b38d0d73-9a20-4894-99bb-2148ee6b10d0" updated="2015-04-09 13:50:03.0" protectedtitlecache="false" titleCache="Taxon C sec. ???" doubtful="false" publish="true" usenamecache="false" excluded="false" taxonstatusunknown="false" taxonomicchildrencount="0" unplaced="false" createdby_id="10" updatedby_id="10" name_id="14"/>
+  <TaxonBase DTYPE="Synonym" id="15" created="2015-03-09 15:51:31.0" uuid="1e240011-aec1-4f94-a934-f3bd0e9df9a5" updated="2015-03-09 15:51:44.0" protectedtitlecache="false" titleCache="HTSynonym C1 sec. ???" doubtful="false" publish="true" usenamecache="false" createdby_id="10" updatedby_id="10" name_id="15"/>
   <TaxonBase DTYPE="Taxon" id="16" created="2015-03-09 15:52:34.0" uuid="eaac797e-cac7-4649-97cf-c7b580076895" updated="2015-03-09 15:52:42.0" protectedtitlecache="false" titleCache="Taxon A sec. Journal Reference 1" doubtful="false" publish="true" usenamecache="false" excluded="false" taxonstatusunknown="false" taxonomicchildrencount="0" unplaced="true" createdby_id="10" updatedby_id="10" name_id="16" sec_id="21"/>
+  <TaxonBase DTYPE="Synonym" id="17" created="2015-03-09 15:52:53.0" uuid="5b6219d0-ae66-4a09-9b5f-af9fc418a085" updated="2015-03-09 15:52:57.0" protectedtitlecache="false" titleCache="HMSynonym A1 sec. ???" doubtful="false" publish="true" usenamecache="false" createdby_id="10" updatedby_id="10" name_id="17"/>
+  <TaxonBase DTYPE="Synonym" id="18" created="2015-03-09 15:53:06.0" uuid="4a85597d-b116-41d1-805c-be8168f5715b" updated="2015-03-09 15:53:07.0" protectedtitlecache="false" titleCache="HTSynonym A1 sec. ???" doubtful="false" publish="true" usenamecache="false" createdby_id="10" updatedby_id="10" name_id="18"/>
   <TaxonBase DTYPE="Taxon" id="19" created="2015-03-09 15:53:21.0" uuid="5004a8e7-b907-4744-b67e-44ccb057ab3b" updated="2015-03-09 15:53:23.0" protectedtitlecache="false" titleCache="Taxon B sec. ???" doubtful="false" publish="true" usenamecache="false" excluded="false" taxonstatusunknown="false" taxonomicchildrencount="0" unplaced="false" createdby_id="10" updatedby_id="10" name_id="19"/>
   <TaxonBase DTYPE="Taxon" id="20" created="2015-03-09 15:53:30.0" uuid="3d71c8b8-3bec-4f5f-ba23-6f9d55ef84e9" updated="2015-03-09 15:53:32.0" protectedtitlecache="false" titleCache="Taxon C sec. ???" doubtful="false" publish="true" usenamecache="false" excluded="false" taxonstatusunknown="false" taxonomicchildrencount="0" unplaced="false" createdby_id="10" updatedby_id="10" name_id="20"/>
+  <TaxonBase DTYPE="Synonym" id="21" created="2015-03-09 15:53:49.0" uuid="cdd27491-1b41-4119-86f5-0ffd33475769" updated="2015-03-09 15:53:52.0" protectedtitlecache="false" titleCache="HTSynonym C1 sec. ???" doubtful="false" publish="true" usenamecache="false" createdby_id="10" updatedby_id="10" name_id="21"/>
   <TaxonBase DTYPE="Taxon" id="30" created="2015-03-10 13:40:30.0" uuid="5f713f69-e03e-4a11-8a55-700fbbf44805" updated="2015-04-09 13:50:03.0" protectedtitlecache="false" titleCache="Taxon D sec. ???" doubtful="false" publish="true" usenamecache="false" excluded="false" taxonstatusunknown="false" taxonomicchildrencount="0" unplaced="false" createdby_id="10" updatedby_id="10" name_id="30"/>
+  <TaxonBase DTYPE="Synonym" id="40" created="2015-04-10 10:31:09.0" uuid="2c4cad2b-051e-4afd-b54f-fdf197d782c3" protectedtitlecache="false" titleCache="Synonym A sec. Book Reference 1" doubtful="false" publish="true" usenamecache="false" name_id="40" sec_id="20"/>
+
+  <SynonymRelationship id="10" created="2015-03-09 15:49:30.0" uuid="f3b087a0-ff03-4a8c-97c1-c06a23d77ac0" updated="2015-03-09 15:50:21.0" doubtful="false" partial="false" proparte="false" createdby_id="10" updatedby_id="10" relatedfrom_id="11" relatedto_id="10" type_id="888"/>
+  <SynonymRelationship id="11" created="2015-03-09 15:50:25.0" uuid="3d0d79b6-37b1-4541-a01d-35f88721a39b" updated="2015-03-09 15:50:54.0" doubtful="false" partial="false" proparte="false" createdby_id="10" updatedby_id="10" relatedfrom_id="12" relatedto_id="10" type_id="889"/>
+  <SynonymRelationship id="12" created="2015-03-09 15:51:31.0" uuid="21e7c6f4-c029-49ad-9cf9-0b14186cd76a" updated="2015-03-09 15:51:44.0" doubtful="false" partial="false" proparte="false" createdby_id="10" updatedby_id="10" relatedfrom_id="15" relatedto_id="14" type_id="889"/>
+  <SynonymRelationship id="13" created="2015-03-09 15:52:53.0" uuid="4bdc85a7-5af4-4744-b372-869bfbdc30e2" updated="2015-03-09 15:52:57.0" doubtful="false" partial="false" proparte="false" createdby_id="10" updatedby_id="10" relatedfrom_id="17" relatedto_id="16" type_id="889"/>
+  <SynonymRelationship id="14" created="2015-03-09 15:53:06.0" uuid="3d2e320c-28cf-4925-b68d-249f95ba684a" updated="2015-03-09 15:53:07.0" doubtful="false" partial="false" proparte="false" createdby_id="10" updatedby_id="10" relatedfrom_id="18" relatedto_id="16" type_id="888"/>
+  <SynonymRelationship id="15" created="2015-03-09 15:53:49.0" uuid="f0e2e376-91a2-459c-b460-1442a0be293a" updated="2015-03-09 15:53:52.0" doubtful="false" partial="false" proparte="false" createdby_id="10" updatedby_id="10" relatedfrom_id="21" relatedto_id="20" type_id="889"/>
+  <SynonymRelationship id="20" created="2015-04-10 10:31:09.0" uuid="60abf634-45ab-450c-b332-966e4db859db" updated="2015-04-10 10:31:09.0" doubtful="false" partial="false" proparte="false" relatedfrom_id="40" relatedto_id="30" type_id="890"/>
 
   <Reference id="20" created="2015-04-02 09:42:49.0" uuid="b7dbc26f-30a0-49e2-9ca6-bbeeefbb9909" updated="2015-04-02 09:42:53.0" protectedtitlecache="true" titleCache="Book Reference 1" abbrevtitlecache="" nomenclaturallyrelevant="false" parsingproblem="0" problemends="-1" problemstarts="-1" protectedabbrevtitlecache="false" refType="BK" createdby_id="10" updatedby_id="10"/>
   <Reference id="21" created="2015-04-02 09:43:04.0" uuid="300ac33d-478a-4a89-ab83-6d89c5142e41" updated="2015-04-02 09:43:07.0" protectedtitlecache="true" titleCache="Journal Reference 1" abbrevtitlecache="" nomenclaturallyrelevant="false" parsingproblem="0" problemends="-1" problemstarts="-1" protectedabbrevtitlecache="false" refType="JOU" createdby_id="10" updatedby_id="10"/>
 
+  <AgentBase DTYPE="Person" id="10" created="2015-03-09 15:49:22.0" uuid="4b8ff099-3e70-4677-8fb6-58b6531b1f28" updated="2015-03-09 15:49:25.0" protectedtitlecache="false" titleCache="A" nomenclaturaltitle="A" createdby_id="10" updatedby_id="10"/>
+  <AgentBase DTYPE="Person" id="11" created="2015-03-09 15:51:11.0" uuid="95e664ad-24dd-4688-ba94-ca319ea4bbda" updated="2015-03-09 15:51:14.0" protectedtitlecache="false" titleCache="B" nomenclaturaltitle="B" createdby_id="10" updatedby_id="10"/>
+  <AgentBase DTYPE="Person" id="12" created="2015-03-09 15:51:24.0" uuid="c194d0c6-6d10-4536-a06d-ba72a097459f" updated="2015-03-09 15:51:25.0" protectedtitlecache="false" titleCache="C" nomenclaturaltitle="C" createdby_id="10" updatedby_id="10"/>
+  <AgentBase DTYPE="Person" id="13" created="2015-03-09 15:52:34.0" uuid="2c92e477-5732-4cbe-bf1a-0427b87a6bb1" updated="2015-03-09 15:52:42.0" protectedtitlecache="false" titleCache="A" nomenclaturaltitle="A" createdby_id="10" updatedby_id="10"/>
+  <AgentBase DTYPE="Person" id="14" created="2015-03-09 15:53:21.0" uuid="fcc573b3-b0a3-46a2-b9ec-041a2c90dee4" updated="2015-03-09 15:53:23.0" protectedtitlecache="false" titleCache="B" nomenclaturaltitle="B" createdby_id="10" updatedby_id="10"/>
+  <AgentBase DTYPE="Person" id="15" created="2015-03-09 15:53:30.0" uuid="2eade852-9862-42ff-b5c4-e17a9e21aa3b" updated="2015-03-09 15:53:32.0" protectedtitlecache="false" titleCache="C" nomenclaturaltitle="C" createdby_id="10" updatedby_id="10"/>
+  <AgentBase DTYPE="Person" id="20" created="2015-03-10 13:40:30.0" uuid="4fc5c7d9-1fbc-4494-bd2d-0e9ccbda0fba" updated="2015-03-10 13:40:31.0" protectedtitlecache="false" titleCache="D" nomenclaturaltitle="D" createdby_id="10" updatedby_id="10"/>
+
   
 </dataset>