commit d4e83e37febf32601f065390770060398ec63a80
Author: Patrick Plitzner <p.plitzner@bgbm.org>
Date:   Wed Apr 26 17:42:08 2017 +0200

    ref #5752 Re-add dependencies needed for creating a new data model

diff --git a/eu.etaxonomy.taxeditor.cdmlib/.classpath b/eu.etaxonomy.taxeditor.cdmlib/.classpath
index 07c07d641..61ebbc5ce 100644
--- a/eu.etaxonomy.taxeditor.cdmlib/.classpath
+++ b/eu.etaxonomy.taxeditor.cdmlib/.classpath
@@ -1,5 +1,13 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <classpath>
+	<classpathentry exported="true" kind="lib" path="lib/lucene-suggest-5.4.1.jar"/>
+	<classpathentry exported="true" kind="lib" path="lib/lucene-sandbox-5.4.1.jar"/>
+	<classpathentry exported="true" kind="lib" path="lib/lucene-analyzers-common-5.4.1.jar"/>
+	<classpathentry exported="true" kind="lib" path="lib/lucene-analyzers-3.6.2.jar"/>
+	<classpathentry exported="true" kind="lib" path="lib/lucene-queryparser-5.4.1.jar"/>
+	<classpathentry exported="true" kind="lib" path="lib/istack-commons-runtime-2.21.jar"/>
+	<classpathentry exported="true" kind="lib" path="lib/istack-commons-tools-2.21.jar"/>
+	<classpathentry exported="true" kind="lib" path="lib/lucene-core-5.4.1.jar"/>
 	<classpathentry exported="true" kind="lib" path="lib/antlr-2.7.7.jar"/>
 	<classpathentry exported="true" kind="lib" path="lib/aopalliance-1.0.jar"/>
 	<classpathentry exported="true" kind="lib" path="lib/avro-1.6.3.jar"/>
diff --git a/eu.etaxonomy.taxeditor.cdmlib/META-INF/MANIFEST.MF b/eu.etaxonomy.taxeditor.cdmlib/META-INF/MANIFEST.MF
index b3610469d..b0a4ccdcc 100644
--- a/eu.etaxonomy.taxeditor.cdmlib/META-INF/MANIFEST.MF
+++ b/eu.etaxonomy.taxeditor.cdmlib/META-INF/MANIFEST.MF
@@ -7,6 +7,12 @@ Eclipse-BundleShape: dir
 Export-Package: com.google.api,
  com.google.api.detect,
  com.google.api.translate,
+ com.sun.istack,
+ com.sun.istack.internal.tools,
+ com.sun.istack.internal.ws,
+ com.sun.istack.localization,
+ com.sun.istack.logging,
+ com.sun.istack.tools,
  eu.etaxonomy.cdm,
  eu.etaxonomy.cdm.api.application,
  eu.etaxonomy.cdm.api.cache,
@@ -276,6 +282,127 @@ Export-Package: com.google.api,
    org.apache.log4j.spi,
    org.w3c.dom,
    org.xml.sax",
+ org.apache.lucene,
+ org.apache.lucene.analysis,
+ org.apache.lucene.analysis.ar,
+ org.apache.lucene.analysis.bg,
+ org.apache.lucene.analysis.br,
+ org.apache.lucene.analysis.ca,
+ org.apache.lucene.analysis.charfilter,
+ org.apache.lucene.analysis.cjk,
+ org.apache.lucene.analysis.ckb,
+ org.apache.lucene.analysis.cn,
+ org.apache.lucene.analysis.commongrams,
+ org.apache.lucene.analysis.compound,
+ org.apache.lucene.analysis.compound.hyphenation,
+ org.apache.lucene.analysis.core,
+ org.apache.lucene.analysis.custom,
+ org.apache.lucene.analysis.cz,
+ org.apache.lucene.analysis.da,
+ org.apache.lucene.analysis.de,
+ org.apache.lucene.analysis.el,
+ org.apache.lucene.analysis.en,
+ org.apache.lucene.analysis.es,
+ org.apache.lucene.analysis.eu,
+ org.apache.lucene.analysis.fa,
+ org.apache.lucene.analysis.fi,
+ org.apache.lucene.analysis.fr,
+ org.apache.lucene.analysis.ga,
+ org.apache.lucene.analysis.gl,
+ org.apache.lucene.analysis.hi,
+ org.apache.lucene.analysis.hu,
+ org.apache.lucene.analysis.hunspell,
+ org.apache.lucene.analysis.hy,
+ org.apache.lucene.analysis.id,
+ org.apache.lucene.analysis.in,
+ org.apache.lucene.analysis.it,
+ org.apache.lucene.analysis.lt,
+ org.apache.lucene.analysis.lv,
+ org.apache.lucene.analysis.miscellaneous,
+ org.apache.lucene.analysis.ngram,
+ org.apache.lucene.analysis.nl,
+ org.apache.lucene.analysis.no,
+ org.apache.lucene.analysis.path,
+ org.apache.lucene.analysis.pattern,
+ org.apache.lucene.analysis.payloads,
+ org.apache.lucene.analysis.position,
+ org.apache.lucene.analysis.pt,
+ org.apache.lucene.analysis.query,
+ org.apache.lucene.analysis.reverse,
+ org.apache.lucene.analysis.ro,
+ org.apache.lucene.analysis.ru,
+ org.apache.lucene.analysis.shingle,
+ org.apache.lucene.analysis.sinks,
+ org.apache.lucene.analysis.snowball,
+ org.apache.lucene.analysis.sr,
+ org.apache.lucene.analysis.standard,
+ org.apache.lucene.analysis.standard.std40,
+ org.apache.lucene.analysis.sv,
+ org.apache.lucene.analysis.synonym,
+ org.apache.lucene.analysis.th,
+ org.apache.lucene.analysis.tokenattributes,
+ org.apache.lucene.analysis.tr,
+ org.apache.lucene.analysis.util,
+ org.apache.lucene.analysis.wikipedia,
+ org.apache.lucene.bkdtree,
+ org.apache.lucene.codecs,
+ org.apache.lucene.codecs.blocktree,
+ org.apache.lucene.codecs.compressing,
+ org.apache.lucene.codecs.idversion,
+ org.apache.lucene.codecs.lucene50,
+ org.apache.lucene.codecs.lucene53,
+ org.apache.lucene.codecs.lucene54,
+ org.apache.lucene.codecs.perfield,
+ org.apache.lucene.collation,
+ org.apache.lucene.collation.tokenattributes,
+ org.apache.lucene.document,
+ org.apache.lucene.index,
+ org.apache.lucene.payloads,
+ org.apache.lucene.queryparser.analyzing,
+ org.apache.lucene.queryparser.classic,
+ org.apache.lucene.queryparser.complexPhrase,
+ org.apache.lucene.queryparser.ext,
+ org.apache.lucene.queryparser.flexible.core,
+ org.apache.lucene.queryparser.flexible.core.builders,
+ org.apache.lucene.queryparser.flexible.core.config,
+ org.apache.lucene.queryparser.flexible.core.messages,
+ org.apache.lucene.queryparser.flexible.core.nodes,
+ org.apache.lucene.queryparser.flexible.core.parser,
+ org.apache.lucene.queryparser.flexible.core.processors,
+ org.apache.lucene.queryparser.flexible.core.util,
+ org.apache.lucene.queryparser.flexible.messages,
+ org.apache.lucene.queryparser.flexible.precedence,
+ org.apache.lucene.queryparser.flexible.precedence.processors,
+ org.apache.lucene.queryparser.flexible.standard,
+ org.apache.lucene.queryparser.flexible.standard.builders,
+ org.apache.lucene.queryparser.flexible.standard.config,
+ org.apache.lucene.queryparser.flexible.standard.nodes,
+ org.apache.lucene.queryparser.flexible.standard.parser,
+ org.apache.lucene.queryparser.flexible.standard.processors,
+ org.apache.lucene.queryparser.simple,
+ org.apache.lucene.queryparser.surround.parser,
+ org.apache.lucene.queryparser.surround.query,
+ org.apache.lucene.queryparser.xml,
+ org.apache.lucene.queryparser.xml.builders,
+ org.apache.lucene.rangetree,
+ org.apache.lucene.sandbox.queries,
+ org.apache.lucene.sandbox.queries.regex,
+ org.apache.lucene.search,
+ org.apache.lucene.search.similarities,
+ org.apache.lucene.search.spans,
+ org.apache.lucene.search.spell,
+ org.apache.lucene.search.suggest,
+ org.apache.lucene.search.suggest.analyzing,
+ org.apache.lucene.search.suggest.document,
+ org.apache.lucene.search.suggest.fst,
+ org.apache.lucene.search.suggest.jaspell,
+ org.apache.lucene.search.suggest.tst,
+ org.apache.lucene.store,
+ org.apache.lucene.util,
+ org.apache.lucene.util.automaton,
+ org.apache.lucene.util.fst,
+ org.apache.lucene.util.mutable,
+ org.apache.lucene.util.packed,
  org.apache.sanselan;uses:="org.apache.sanselan.common,org.apache.sanselan.common.byteSources",
  org.apache.xerces.dom,
  org.h2.jdbc,
@@ -302,6 +429,10 @@ Export-Package: com.google.api,
  org.hibernate.proxy,
  org.hibernate.proxy.pojo.javassist,
  org.hibernate.search,
+ org.hibernate.search.backend.impl.lucene,
+ org.hibernate.search.backend.impl.lucene.analysis,
+ org.hibernate.search.backend.impl.lucene.overrides,
+ org.hibernate.search.backend.impl.lucene.works,
  org.hibernate.search.spatial.impl,
  org.hibernate.type,
  org.jadira.usertype.dateandtime.joda,
@@ -717,5 +848,13 @@ Bundle-ClassPath: .,
  lib/unitils-inject-3.4.2.jar,
  lib/unitils-mock-3.4.2.jar,
  lib/unitils-orm-3.4.2.jar,
- lib/unitils-spring-3.4.2.jar
+ lib/unitils-spring-3.4.2.jar,
+ lib/lucene-core-5.4.1.jar,
+ lib/istack-commons-runtime-2.21.jar,
+ lib/istack-commons-tools-2.21.jar,
+ lib/lucene-queryparser-5.4.1.jar,
+ lib/lucene-analyzers-3.6.2.jar,
+ lib/lucene-analyzers-common-5.4.1.jar,
+ lib/lucene-sandbox-5.4.1.jar,
+ lib/lucene-suggest-5.4.1.jar
 Import-Package: eu.etaxonomy.cdm.api.application
diff --git a/eu.etaxonomy.taxeditor.cdmlib/build.properties b/eu.etaxonomy.taxeditor.cdmlib/build.properties
index f5a8673db..e12cacfee 100644
--- a/eu.etaxonomy.taxeditor.cdmlib/build.properties
+++ b/eu.etaxonomy.taxeditor.cdmlib/build.properties
@@ -212,7 +212,15 @@ bin.includes = META-INF/,\
                lib/unitils-inject-3.4.2.jar,\
                lib/unitils-mock-3.4.2.jar,\
                lib/unitils-orm-3.4.2.jar,\
-               lib/unitils-spring-3.4.2.jar
+               lib/unitils-spring-3.4.2.jar,\
+               lib/lucene-core-5.4.1.jar,\
+               lib/istack-commons-runtime-2.21.jar,\
+               lib/istack-commons-tools-2.21.jar,\
+               lib/lucene-queryparser-5.4.1.jar,\
+               lib/lucene-analyzers-3.6.2.jar,\
+               lib/lucene-analyzers-common-5.4.1.jar,\
+               lib/lucene-sandbox-5.4.1.jar,\
+               lib/lucene-suggest-5.4.1.jar
 
 jars.compile.order = .
 output.. = bin/
diff --git a/eu.etaxonomy.taxeditor.cdmlib/lib/istack-commons-runtime-2.21.jar b/eu.etaxonomy.taxeditor.cdmlib/lib/istack-commons-runtime-2.21.jar
new file mode 100644
index 000000000..aa950a84e
Binary files /dev/null and b/eu.etaxonomy.taxeditor.cdmlib/lib/istack-commons-runtime-2.21.jar differ
diff --git a/eu.etaxonomy.taxeditor.cdmlib/lib/istack-commons-tools-2.21.jar b/eu.etaxonomy.taxeditor.cdmlib/lib/istack-commons-tools-2.21.jar
new file mode 100644
index 000000000..acfa7e3cc
Binary files /dev/null and b/eu.etaxonomy.taxeditor.cdmlib/lib/istack-commons-tools-2.21.jar differ
diff --git a/eu.etaxonomy.taxeditor.cdmlib/lib/lucene-analyzers-3.6.2.jar b/eu.etaxonomy.taxeditor.cdmlib/lib/lucene-analyzers-3.6.2.jar
new file mode 100644
index 000000000..752c71448
Binary files /dev/null and b/eu.etaxonomy.taxeditor.cdmlib/lib/lucene-analyzers-3.6.2.jar differ
diff --git a/eu.etaxonomy.taxeditor.cdmlib/lib/lucene-analyzers-common-5.4.1.jar b/eu.etaxonomy.taxeditor.cdmlib/lib/lucene-analyzers-common-5.4.1.jar
new file mode 100644
index 000000000..bcbeedb93
Binary files /dev/null and b/eu.etaxonomy.taxeditor.cdmlib/lib/lucene-analyzers-common-5.4.1.jar differ
diff --git a/eu.etaxonomy.taxeditor.cdmlib/lib/lucene-core-5.4.1.jar b/eu.etaxonomy.taxeditor.cdmlib/lib/lucene-core-5.4.1.jar
new file mode 100644
index 000000000..769566bc8
Binary files /dev/null and b/eu.etaxonomy.taxeditor.cdmlib/lib/lucene-core-5.4.1.jar differ
diff --git a/eu.etaxonomy.taxeditor.cdmlib/lib/lucene-queryparser-5.4.1.jar b/eu.etaxonomy.taxeditor.cdmlib/lib/lucene-queryparser-5.4.1.jar
new file mode 100644
index 000000000..f7c2e477c
Binary files /dev/null and b/eu.etaxonomy.taxeditor.cdmlib/lib/lucene-queryparser-5.4.1.jar differ
diff --git a/eu.etaxonomy.taxeditor.cdmlib/lib/lucene-sandbox-5.4.1.jar b/eu.etaxonomy.taxeditor.cdmlib/lib/lucene-sandbox-5.4.1.jar
new file mode 100644
index 000000000..530aa27f0
Binary files /dev/null and b/eu.etaxonomy.taxeditor.cdmlib/lib/lucene-sandbox-5.4.1.jar differ
diff --git a/eu.etaxonomy.taxeditor.cdmlib/lib/lucene-suggest-5.4.1.jar b/eu.etaxonomy.taxeditor.cdmlib/lib/lucene-suggest-5.4.1.jar
new file mode 100644
index 000000000..348a75501
Binary files /dev/null and b/eu.etaxonomy.taxeditor.cdmlib/lib/lucene-suggest-5.4.1.jar differ