commit 84bff3eb1ad29129cd181912d9a9b97d693c9fc7
Author: Andreas Müller <a.mueller@bgbm.org>
Date:   Thu Jun 25 01:56:43 2020 +0200

    cleanup

diff --git a/eu.etaxonomy.taxeditor.bulkeditor/src/main/java/eu/etaxonomy/taxeditor/bulkeditor/input/ReferenceEditorInput.java b/eu.etaxonomy.taxeditor.bulkeditor/src/main/java/eu/etaxonomy/taxeditor/bulkeditor/input/ReferenceEditorInput.java
index cd00008cd..1ea5c4d72 100644
--- a/eu.etaxonomy.taxeditor.bulkeditor/src/main/java/eu/etaxonomy/taxeditor/bulkeditor/input/ReferenceEditorInput.java
+++ b/eu.etaxonomy.taxeditor.bulkeditor/src/main/java/eu/etaxonomy/taxeditor/bulkeditor/input/ReferenceEditorInput.java
@@ -26,9 +26,7 @@ import eu.etaxonomy.taxeditor.bulkeditor.input.sortprovider.IdentifiableEntitySo
 import eu.etaxonomy.taxeditor.bulkeditor.input.sortprovider.ReferenceSortProvider;
 import eu.etaxonomy.taxeditor.store.CdmStore;
 
-
 /**
- *
  * @author p.ciardelli
  * @created 25.06.2009
  */
@@ -137,7 +135,7 @@ public class ReferenceEditorInput extends AbstractBulkEditorInput<Reference> {
 		return BulkEditorInputType.REFERENCE.label;
 	}
 
-	public static AbstractBulkEditorInput getInstance() {
+	public static AbstractBulkEditorInput<Reference> getInstance() {
 		if (instance == null) {
 			instance = new ReferenceEditorInput();
 		}
@@ -163,11 +161,11 @@ public class ReferenceEditorInput extends AbstractBulkEditorInput<Reference> {
     }
 
 	@Override
-	public List listEntities(IIdentifiableEntityServiceConfigurator configurator) {
+	public List<Reference> listEntities(IIdentifiableEntityServiceConfigurator configurator) {
 		return CdmStore.getSearchManager().findReferences(configurator);
 	}
 
-	// Entity persistence
+	//entity persistence
 
 	@Override
 	public Reference loadEntity(UUID entityUuid) {
diff --git a/eu.etaxonomy.taxeditor.cdmlib/src/main/java/org/springframework/remoting/httpinvoker/CachingHttpInvokerProxyFactoryBean.java b/eu.etaxonomy.taxeditor.cdmlib/src/main/java/org/springframework/remoting/httpinvoker/CachingHttpInvokerProxyFactoryBean.java
index fdf7f1acc..3004b7f0d 100644
--- a/eu.etaxonomy.taxeditor.cdmlib/src/main/java/org/springframework/remoting/httpinvoker/CachingHttpInvokerProxyFactoryBean.java
+++ b/eu.etaxonomy.taxeditor.cdmlib/src/main/java/org/springframework/remoting/httpinvoker/CachingHttpInvokerProxyFactoryBean.java
@@ -82,12 +82,6 @@ public class CachingHttpInvokerProxyFactoryBean extends HttpInvokerProxyFactoryB
         }
     }
 
-    /**
-     * @param invocation
-     * @param originalInvocation
-     * @return
-     * @throws Exception
-     */
     private RemoteInvocationResult handleGeneralRequest(RemoteInvocation invocation,
             MethodInvocation originalInvocation) throws Exception {
         RemoteInvocationResult invocationResult = doExecuteRequest(invocation, originalInvocation);
@@ -106,7 +100,6 @@ public class CachingHttpInvokerProxyFactoryBean extends HttpInvokerProxyFactoryB
                 invocationResult = new RemoteInvocationResult(cdmEntitySessionManager().load(invocationResult.getValue(), false));
                 logger.debug("Entity cached without updating cached data" );
             }
-
         }
         cache(invocation, invocationResult);
         return  invocationResult;
@@ -116,12 +109,6 @@ public class CachingHttpInvokerProxyFactoryBean extends HttpInvokerProxyFactoryB
 
     }
 
-    /**
-     * @param invocation
-     * @param originalInvocation
-     * @return
-     * @throws Exception
-     */
     private RemoteInvocationResult handleTermRequest(RemoteInvocation invocation, MethodInvocation originalInvocation)
             throws Exception {
         RemoteInvocationResult invocationResult = null;
@@ -141,12 +128,6 @@ public class CachingHttpInvokerProxyFactoryBean extends HttpInvokerProxyFactoryB
         return invocationResult;
     }
 
-    /**
-     * @param invocation
-     * @param originalInvocation
-     * @return
-     * @throws Exception
-     */
     private RemoteInvocationResult doExecuteRequest(RemoteInvocation invocation, MethodInvocation originalInvocation)
             throws Exception {
 
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/operation/RemotingCdmUpdateOperation.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/operation/RemotingCdmUpdateOperation.java
index baa8461cb..9b180ceaa 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/operation/RemotingCdmUpdateOperation.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/operation/RemotingCdmUpdateOperation.java
@@ -24,11 +24,9 @@ import org.eclipse.e4.ui.workbench.modeling.EPartService;
 import eu.etaxonomy.cdm.api.application.CdmChangeEvent.Action;
 import eu.etaxonomy.cdm.api.service.UpdateResult;
 
-
 /**
  * @author cmathew
  * @date 16 Jun 2015
- *
  */
 public abstract class RemotingCdmUpdateOperation extends RemotingCdmOperation {
 
@@ -39,9 +37,6 @@ public abstract class RemotingCdmUpdateOperation extends RemotingCdmOperation {
     protected MPart activePart = null;
     protected MApplication application = null;
 
-    /**
-     * @param label
-     */
     public RemotingCdmUpdateOperation(String label, Action action, Object source, boolean async,
     		EPartService partService,
     		MPart activePart,
@@ -57,9 +52,6 @@ public abstract class RemotingCdmUpdateOperation extends RemotingCdmOperation {
 
     }
 
-    /* (non-Javadoc)
-     * @see eu.etaxonomy.taxeditor.operation.RemotingCdmOperation#doExecute(org.eclipse.core.runtime.IProgressMonitor, org.eclipse.core.runtime.IAdaptable)
-     */
     @Override
     protected boolean doExecute(IProgressMonitor monitor, IAdaptable info) {
         updateResult = new UpdateResult();
@@ -85,12 +77,8 @@ public abstract class RemotingCdmUpdateOperation extends RemotingCdmOperation {
         if(success && updateResult != null) {
             fireDataChangeEvent(updateResult);
         }
-
     }
 
-    /* (non-Javadoc)
-     * @see eu.etaxonomy.taxeditor.operation.RemotingCdmOperation#onComplete(boolean)
-     */
     @Override
     protected IStatus onComplete(boolean success) {
 
@@ -139,6 +127,4 @@ public abstract class RemotingCdmUpdateOperation extends RemotingCdmOperation {
         }
         return null;
     }
-
-
 }
diff --git a/eu.etaxonomy.taxeditor.store/src/test/java/eu/etaxonomy/taxeditor/store/operations/RemotingTestUpdateOperation.java b/eu.etaxonomy.taxeditor.store/src/test/java/eu/etaxonomy/taxeditor/store/operations/RemotingTestUpdateOperation.java
index 8bde5267f..1233bb086 100644
--- a/eu.etaxonomy.taxeditor.store/src/test/java/eu/etaxonomy/taxeditor/store/operations/RemotingTestUpdateOperation.java
+++ b/eu.etaxonomy.taxeditor.store/src/test/java/eu/etaxonomy/taxeditor/store/operations/RemotingTestUpdateOperation.java
@@ -21,7 +21,6 @@ import eu.etaxonomy.taxeditor.operation.RemotingCdmUpdateOperation;
 /**
  * @author cmathew
  * @date 26 Jun 2015
- *
  */
 public class RemotingTestUpdateOperation extends RemotingCdmUpdateOperation {
 
@@ -31,13 +30,6 @@ public class RemotingTestUpdateOperation extends RemotingCdmUpdateOperation {
     private Exception exception;
     private CdmEntityIdentifier cei;
 
-
-    /**
-     * @param label
-     * @param action
-     * @param source
-     * @param async
-     */
     public RemotingTestUpdateOperation(UpdateResult result,
             Object source,
             boolean async) {
@@ -59,9 +51,6 @@ public class RemotingTestUpdateOperation extends RemotingCdmUpdateOperation {
         this.cei = cei;
     }
 
-    /* (non-Javadoc)
-     * @see eu.etaxonomy.taxeditor.operation.RemotingCdmUpdateOperation#doUpdateExecute(org.eclipse.core.runtime.IProgressMonitor, org.eclipse.core.runtime.IAdaptable)
-     */
     @Override
     protected UpdateResult doUpdateExecute(IProgressMonitor monitor, IAdaptable info) throws Exception {
         ITestService testService = CdmApplicationState.getTestService();
diff --git a/eu.etaxonomy.taxeditor.test/src/test/java/eu/etaxonomy/taxeditor/operation/RemotingCdmUpdateOperationTest.java b/eu.etaxonomy.taxeditor.test/src/test/java/eu/etaxonomy/taxeditor/operation/RemotingCdmUpdateOperationTest.java
index 60a47be16..4bc3affc2 100644
--- a/eu.etaxonomy.taxeditor.test/src/test/java/eu/etaxonomy/taxeditor/operation/RemotingCdmUpdateOperationTest.java
+++ b/eu.etaxonomy.taxeditor.test/src/test/java/eu/etaxonomy/taxeditor/operation/RemotingCdmUpdateOperationTest.java
@@ -68,7 +68,7 @@ public class RemotingCdmUpdateOperationTest extends BaseOperationTest {
         TaxonNode taxonNode4 = (TaxonNode) ProxyUtils.deproxy(taxonNodeService.load(taxonNodeUuid4));
         TaxonNode taxonNode5 = (TaxonNode) ProxyUtils.deproxy(taxonNodeService.load(taxonNodeUuid5));
 
-        taxonNodes = new HashSet<TaxonNode>();
+        taxonNodes = new HashSet<>();
         taxonNodes.add(taxonNode1);
         taxonNodes.add(taxonNode2);
         taxonNodes.add(taxonNode3);
@@ -95,14 +95,14 @@ public class RemotingCdmUpdateOperationTest extends BaseOperationTest {
         TaxonNode taxonNode4 = (TaxonNode) ProxyUtils.deproxy(taxonNodeService.load(taxonNodeUuid4));
         TaxonNode taxonNode5 = (TaxonNode) ProxyUtils.deproxy(taxonNodeService.load(taxonNodeUuid5));
 
-        taxonNodes = new HashSet<TaxonNode>();
+        taxonNodes = new HashSet<>();
         taxonNodes.add(taxonNode1);
         taxonNodes.add(taxonNode2);
         taxonNodes.add(taxonNode3);
         taxonNodes.add(taxonNode4);
         taxonNodes.add(taxonNode5);
 
-        ceis = new HashSet<CdmEntityIdentifier>();
+        ceis = new HashSet<>();
         ceis.add(new CdmEntityIdentifier(taxonNode3.getId(),TaxonNode.class));
         ceis.add(new CdmEntityIdentifier(taxonNode4.getId(),TaxonNode.class));
         ceis.add(new CdmEntityIdentifier(taxonNode5.getId(),TaxonNode.class));
@@ -128,14 +128,14 @@ public class RemotingCdmUpdateOperationTest extends BaseOperationTest {
         TaxonNode taxonNode4 = (TaxonNode) ProxyUtils.deproxy(taxonNodeService.load(taxonNodeUuid4));
         TaxonNode taxonNode5 = (TaxonNode) ProxyUtils.deproxy(taxonNodeService.load(taxonNodeUuid5));
 
-        taxonNodes = new HashSet<TaxonNode>();
+        taxonNodes = new HashSet<>();
         taxonNodes.add(taxonNode1);
         taxonNodes.add(taxonNode2);
         taxonNodes.add(taxonNode3);
         taxonNodes.add(taxonNode4);
         taxonNodes.add(taxonNode5);
 
-        ceis = new HashSet<CdmEntityIdentifier>();
+        ceis = new HashSet<>();
         ceis.add(new CdmEntityIdentifier(taxonNode3.getId(),TaxonNode.class));
         ceis.add(new CdmEntityIdentifier(taxonNode4.getId(),TaxonNode.class));
         ceis.add(new CdmEntityIdentifier(taxonNode5.getId(),TaxonNode.class));
@@ -160,7 +160,7 @@ public class RemotingCdmUpdateOperationTest extends BaseOperationTest {
         TaxonNode taxonNode = (TaxonNode) ProxyUtils.deproxy(taxonNodeService.load(taxonNodeUuid1));
         CdmEntityIdentifier cei = new CdmEntityIdentifier(taxonNode.getId(), TaxonNode.class);
 
-        taxonNodes = new HashSet<TaxonNode>();
+        taxonNodes = new HashSet<>();
         taxonNodes.add(taxonNode);
 
         int taxonNodeCountChildren = taxonNode.getCountChildren();